Attribute VB_Name = "modSysMenu"
Option Explicit
'
' Subclassing der frmMain, um das Click-Ereignis beim Systemmen abzufangen.
'
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_WNDPROC = (-4&)
Public Const WM_SYSCOMMAND = &H112

Dim PrevWndProc&, mnuHandle&

'
' Initialisieren des Mens.
'
Public Sub Init(hwnd&)
    mnuHandle = GetSystemMenu(hwnd, False)
    
    Call AppendMenu(mnuHandle, MF_SEPARATOR, 0, "")
    '  frmMain immer im Vordergrund - Meneintrag anhaken.
    Call SetOnTop(frmMain, AlwaysOnTop)
    Call AppendMenu(mnuHandle, MF_STRING Or MF_CHECKED, &H200, "&Immer im Vordergrund")
    Call AppendMenu(mnuHandle, MF_SEPARATOR, 0, "")
    Call AppendMenu(mnuHandle, MF_STRING, &H201, "Inf&o ber " & App.Title)
    
    PrevWndProc = SetWindowLong(mnuHandle, GWL_WNDPROC, AddressOf SubWndProc)
    
    PrevWndProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf SubWndProc)
End Sub

Public Sub Terminate(hwnd&)
    ' Subclassing beenden.
    Call SetWindowLong(hwnd, GWL_WNDPROC, PrevWndProc)
End Sub

'
' Wertet aus, ob ein Meneintrag geklickt wurde.
'
' wParam - Meneintrag, der angeklickt wurde.
'
Public Function SubWndProc(ByVal hwnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim Result&
    
    If MSG = WM_SYSCOMMAND Then
        Select Case wParam
            '
            ' Immer im Vordergrund.
            '
            Case &H200
                Result = GetMenuState(mnuHandle, &H200, MF_BYCOMMAND)
                
                If Result And MF_CHECKED Then
                    ' Haken entfernen.
                    Call CheckMenuItem(mnuHandle, &H200, MF_BYCOMMAND Or MF_UNCHECKED)
                    Call SetOnTop(frmMain, Default)
                Else
                    ' Haken hinzufgen.
                    Call CheckMenuItem(mnuHandle, &H200, MF_BYCOMMAND Or MF_CHECKED)
                    Call SetOnTop(frmMain, AlwaysOnTop)
                End If
                
            '
            ' Info-Dialog anzeigen.
            '
            Case &H201
                frmAbout.Show 1, frmMain
                
        End Select
    End If
    
    SubWndProc = CallWindowProc(PrevWndProc, hwnd, MSG, wParam, lParam)
End Function
